<!-- components/ImageCapture.vue -->

<template>
  <div>
    <video ref="video" autoplay playsinline></video>
    <button @click="startCamera">Start Camera</button>
    <button @click="takePhoto">Take Photo</button>
    <input
      type="file"
      ref="fileInput"
      style="display: none"
      @change="handleFileChange"
      accept="image/*"
    />
    <img :src="capturedImage" alt="Captured Image" v-if="capturedImage" />
  </div>
</template>

<script>
export default {
  data() {
    return {
      mediaStream: null,
      capturedImage: null,
    };
  },
  methods: {
    async startCamera() {
      try {
        this.mediaStream = await navigator.mediaDevices.getUserMedia({
          video: true,
        });
        this.$refs.video.srcObject = this.mediaStream;
      } catch (error) {
        console.error("Error accessing camera:", error);
      }
    },
    async takePhoto() {
      const canvas = document.createElement("canvas");
      canvas.width = this.$refs.video.videoWidth;
      canvas.height = this.$refs.video.videoHeight;
      canvas
        .getContext("2d")
        .drawImage(this.$refs.video, 0, 0, canvas.width, canvas.height);
      const dataURL = canvas.toDataURL("image/jpeg");
      this.capturedImage = dataURL;
    },
    handleFileChange() {
      const file = this.$refs.fileInput.files[0];
      const reader = new FileReader();

      reader.onload = (e) => {
        this.capturedImage = e.target.result;
      };

      reader.readAsDataURL(file);
    },
  },
};
</script>
